rem @echo off
goto one
rem WhichArc -  30 minutes of frenzied activity, followed by
rem		hours of testing and optimizing...
rem Version 0.1, (c) Apr 11, 1996 by MontyL @ Black Mountain

rem   Citadel, in all its configurability, has one great flaw
rem in the networking code, which is that the #DEFAULT #ZIP
rem decompress command is _always_ used when a netpacket is
rem recieved, preventing the use of archivers other than PKZip.
rem Since you _have_ to have PKUNZIP as your decompressor, due
rem to the fact that every node uses it, you're stuck with it.

rem   Not any more...  WhichArc came about as a way to determine
rem the compression method used by a netpartner, use that method
rem to decompress the packet, circumventing the 'locked' nature
rem of the Net6.9 specification.

rem   I had first decided to code this in C++, only to find that
rem my severe lack of knowledge only resulted in p-code that I
rem would have to have someone else translate and write for me.
rem Instead, using the DOS commands available, and a penchant
rem for writing massive batch files...  Here you go!  :)

rem April 13, 1996
rem   Currently, only ARJ, LZH, RAR, ZIP and ZOO are supported.
rem Additional formats may be added fairly easily, just follow
rem the format of the individual sections below, adding to them.
rem   I highly suggest that, if you add a format, you sort it
rem into the process list in such a way that the compression
rem scheme with the largest identifying information (see LZH for
rem example) be placed at the top, the one with the least (see
rem PKZip) at the bottom, as I've already created a ZOO file with
rem the letters 'PK' inside that WhichArc tried to extract using
rem PKUnzip...  Not entirely the correct thing to do...  ;)
rem   I plan on adding every format available (including SIT, of
rem all the silly thoughts... ;), so send any archiver you find
rem my way; I'll put it in.  "It's In There" doesn't only apply
rem to Ragu...  }:>

rem   The whole idea behind this:  Instead of "pkunzip" in the
rem #DEFAULT #ZIP entry, "!whicharc" will _always_ extract the
rem packet, no matter which compressor was used to create it.
rem   For those of us running additional processing, just change
rem "pkunzip" in our batch to "call whicharc".

rem   Any and all questions concerning WhichArc should be routed to
rem MontyL@bkm.bli or montyl@az.com.

rem   Best of luck to you!
:one
find /n "-lh5-" %1 > nul
if errorlevel 2 goto oops
if errorlevel 1 goto two
echo File %1 is LZH!
lharc e %1
goto end

:two
find /n "Rar!" %1 > nul
if errorlevel 1 goto three
echo File %1 is RAR!
rar e -o+ -std %1
goto end

:three
find /i /n ".arj" %1 > nul
if errorlevel 1 goto four
echo File %1 is ARJ!
arj e -jyo %1
goto end

:four
find /n "ZOO" %1 > nul
if errorlevel 1 goto five
echo File %1 is ZOO!
zoo eO %1
goto end

:five
find /n "PK" %1 > NUL
if errorlevel 1 goto fail
echo File %1 is PKZipped!
pkunzip -o %1
goto end

:fail
echo File %1 is not ARJ, LZH, RAR, ZIP or ZOO.
echo Decompression method unknown.  Convert to a recognized
echo format and try again.
goto end

:oops
echo File not found, or other error occurred.  Check the spelling
echo and path of %1, and try again.

:end
